﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace OmaKontrolli
{
    /// <summary>
    /// Interaction logic for UserControl1.xaml
    /// </summary>
    public partial class UserControl1 : UserControl
    {
        public UserControl1()
        {
            InitializeComponent();
        }

        // perusversio routedeventistä käyttäen normaalia routedeventargsia eli mitään omaa dataa ei liikutella
        public static readonly RoutedEvent OmaEvent =
    EventManager.RegisterRoutedEvent("Oma", RoutingStrategy.Bubble,
    typeof(RoutedEventHandler), typeof(UserControl1));

        public event RoutedEventHandler Oma
        {
            add { AddHandler(OmaEvent, value); }
            remove { RemoveHandler(OmaEvent, value); }
        }

        void RaiseOmaEvent()
        {   // huom. tässä pitää olla luontiparametrina UserControl1.OmaEvent. Tämä
            // erottaa eri eventit toisistaan
            RoutedEventArgs newEventArgs = new RoutedEventArgs(UserControl1.OmaEvent);
            RaiseEvent(newEventArgs);
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            RaiseOmaEvent();

        }

// toinen versio jossa käytössä on omaa dataa eli tarvitaan oma luokka argumentteja varten
// tarvitaan myös oma delegate koska perusversio käyttää normaalia routedeventargsia
        public delegate void OmaArgsRoutedEventHandler(object sender, OmaEventArgs e);
// oma luokka oman datan siirtelyyn
        public class OmaEventArgs : RoutedEventArgs
        {
            private int _luku = 0;
            public int luku
            {
                get { return _luku;}
                set { _luku = value; }
            }
            public OmaEventArgs(RoutedEvent routedEvent, int l = 0) : base(routedEvent)
            {
                luku = l;
            }
        }

// määritellään routedevent. Huomatkaa typeof pitää olla nyt OmaArgsRoutedEventHandler eli 
// sama mitä yllä luotiin
        public static readonly RoutedEvent OmaArgsEvent =
EventManager.RegisterRoutedEvent("OmaArgs", RoutingStrategy.Bubble,
typeof(OmaArgsRoutedEventHandler), typeof(UserControl1));

        public event RoutedEventHandler OmaArgs
        {
            add { AddHandler(OmaArgsEvent, value); }
            remove { RemoveHandler(OmaArgsEvent, value); }
        }

        void RaiseOmaArgsEvent()
        { // nyt luodaan oma args-luokan esiintymä, tarvitaan routeventin tyyppi (OmaArgsEvent! ei vahingossakaan sama kuin edellisessä!) ja varsinainen oma parametri
            OmaEventArgs newEventArgs = new OmaEventArgs(UserControl1.OmaArgsEvent, 10);
            RaiseEvent(newEventArgs);
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            RaiseOmaArgsEvent();

        }


    }
}
